
# q-expansion of newform 819.2.a.f, downloaded from the LMFDB on 19 April 2024.

# We generate the q-expansion using the Hecke eigenvalues a_p at the primes.
# Each a_p is given as a linear combination
# of the following basis for the coefficient ring.

def make_data():

    from sage.all import prod, floor, prime_powers, gcd, QQ, primes_first_n, next_prime, RR

    def discrete_log(elts, gens, mod):
        # algorithm 2.2, page 16 of https://arxiv.org/abs/0903.2785
        def table_gens(gens, mod):
            T = [1]
            n = len(gens)
            r = [None]*n
            s = [None]*n
            for i in range(n):
                beta = gens[i]
                r[i] = 1
                N = len(T)
                while beta not in T:
                    for Tj in T[:N]:
                        T.append((beta*Tj) % mod)
                    beta = (beta*gens[i]) % mod
                    r[i] += 1
                s[i] = T.index(beta)
            return T, r, s
        T, r, s = table_gens(gens, mod)
        n = len(gens)
        N = [ prod(r[:j]) for j in range(n) ]
        Z = lambda s: [ (floor(s/N[j]) % r[j]) for j in range(n)]
        return [Z(T.index(elt % mod)) for elt in elts]
    def extend_multiplicatively(an):
        for pp in prime_powers(len(an)-1):
            for k in range(1, (len(an) - 1)//pp + 1):
                if gcd(k, pp) == 1:
                    an[pp*k] = an[pp]*an[k]
    from sage.all import PolynomialRing, NumberField
    R = PolynomialRing(QQ, "x")
    f = R(poly_data)
    K = NumberField(f, "a")
    betas = [K.gens()[0]**i for i in range(len(poly_data))]
    convert_elt_to_field = lambda elt: sum(c*beta for c, beta in zip(elt, betas))
    # convert aps to K elements
    primes = primes_first_n(len(aps_data))
    good_primes = [p for p in primes if not p.divides(level)]
    aps = map(convert_elt_to_field, aps_data)
    if not hecke_ring_character_values:
        # trivial character
        char_values = dict(zip(good_primes, [1]*len(good_primes)))
    else:
        gens = [elt[0] for elt in hecke_ring_character_values]
        gens_values = [convert_elt_to_field(elt[1]) for elt in hecke_ring_character_values]
        char_values = dict([(
            p,prod(g**k for g, k in zip(gens_values, elt)))
            for p, elt in zip(good_primes, discrete_log(good_primes, gens, level))
            ])
    an_list_bound = next_prime(primes[-1])
    an = [0]*an_list_bound
    an[1] = 1
    
    from sage.all import PowerSeriesRing
    PS = PowerSeriesRing(K, "q")
    for p, ap in zip(primes, aps):
        if p.divides(level):
            euler_factor = [1, -ap]
        else:
            euler_factor = [1, -ap, p**(weight - 1) * char_values[p]]
        k = RR(an_list_bound).log(p).floor() + 1
        foo = (1/PS(euler_factor)).padded_list(k)
        for i in range(1, k):
            an[p**i] = foo[i]
    extend_multiplicatively(an)
    return PS(an)
level = 819
weight = 2
poly_data = [0, 1]

# The basis for the coefficient ring is just the power basis
# in the root of the defining polynomial above.
hecke_ring_character_values = None
aps_data = [[2], [0], [3], [-1], [6], [-1], [-4], [5], [-3], [5], [-3], [-4], [6], [-1], [-7], [9], [-8], [-10], [-6], [8], [-13], [3], [-15], [-3], [7], [14], [-4], [4], [-2], [3], [-4], [-8], [-4], [-18], [18], [0], [-8], [-4], [-5], [8], [-23], [14], [8], [22], [-2], [4], [-5], [15], [-20], [14], [-15], [4], [-17], [26], [2], [15], [0], [8], [1], [30], [16], [19], [-33], [6], [22], [24], [22], [17], [32], [11], [10], [-20], [14], [30], [-6], [36], [-30], [-13], [32], [-13], [10], [-12], [-6], [12], [-22], [-19], [-36], [0], [22], [-14], [22], [11], [-26], [12], [-16], [-2], [19], [-40], [10], [-40], [-7], [12], [-4], [-7], [-17], [2], [-39], [27], [-11], [-10], [2], [8], [30], [20], [22], [-9], [8], [-18], [-18], [-17], [-33], [1], [-22], [12], [11], [27], [-10], [-18], [46], [51], [-26], [-36], [-17], [-15], [-9], [-35], [-54], [37], [-18], [31], [-52], [6], [-32], [-4], [-10], [8], [45], [6], [-2], [32], [0], [30], [-4], [12], [7], [15], [8], [-5], [-8], [-55], [18], [39], [22], [-38], [-10], [-17], [4], [-28]]
